procedure clearscr12h;assembler;
asm
  mov   es,SegA000
  mov   di,00h
  mov   ax,00h
  mov   cx,19200
  rep   stosw
end;

procedure putpixel12h(x,y:integer;c:byte);assembler;
asm
  mov   ax,SegA000      {Calculate Offset}
  mov   es,ax
  mov   bx,[y]
  mov   di,bx
  shl   di,6
  shl   bx,4
  add   di,bx
 
  mov   cx,[x]
  mov   bx,cx
  shr   bx,3            {/8}
  add   di,bx           {80*y+ (x/8)}

  and   cx,7            {Get Bit that Changes}
  mov   ah,128
  shr   ah,cl
  mov   dx,03ceh
  mov   al,8
  out   dx,ax
  mov   dl,[es:di]
  mov   al,[c]
  mov   [es:di],al
end;

procedure vline12h(x,y,length:integer;color:byte);assembler;
asm
  mov   ax,SegA000      {Calculate Offset}
  mov   es,ax
  mov   bx,[y]
  mov   di,bx
  shl   di,6            {80*y}
  shl   bx,4
  add   di,bx
  mov   cx,[x]
  mov   bx,cx
  shr   bx,3            {/8}
  add   di,bx           {80*y+ (x/8)}
  and   cx,7            {Get Bit that Changes}
  mov   ah,80h
  shr   ah,cl           {BitMask Value}
  mov   dx,03ceh        {Graphics Controller}
  mov   al,8            {BitMask Register}
  out   dx,ax           {BitMask Setup}
  mov   bx,[length]
  mov   al,[color]
@D_L:
  mov   dl,[es:di]
  mov   [es:di],al      {Put Byte at Offset}
  add   di,80
  dec   bx
  jnz   @D_L
 end;

procedure hline12h(x,y,length:integer;color:byte);assembler;
asm
  mov   bx,[x]
  mov   si,[Length]
  or    si,si           {Check if Length=0}
  jz    @D_End           {If So then jump to End}
  mov   dx,03ceh        {Graphics Controller}
  mov   ax,SegA000      {Calculate Offset}
  mov   es,ax
  mov   ax,[y]
  mov   di,ax
  shl   di,6            {80*y}
  shl   ax,4
  add   di,ax
  mov   ax,bx
  shr   ax,3            {/8}
  add   di,ax           {80*y+ (x/8)}
  mov   cx,bx           {Get StartBit}
  and   cx,07h
  mov   ax,si
  add   ax,cx
  cmp   ax,8            {Is x+Length<One Byte}
  jb    @D_One
  mov   ah,0ffh         {11111111b}
  shr   ah,cl           {BitMask}
  mov   al,8            {BitMask Register}
  out   dx,ax           {Write BitMask}
  mov   al,[es:di]
  mov   al,[Color]
  mov   [es:di],al
  inc   di
  mov   al,8            {BitMask Register}
  mov   ah,0ffh         {BitMask}
  out   dx,ax           {Write BitMask}
  mov   ax,si
  mov   ch,8
  sub   ch,cl
  mov   cl,ch
  xor   ch,ch
  sub   ax,cx
  shr   ax,3            {Length div 8}
  mov   cx,ax
  mov   al,[Color]
  rep   stosb
  mov   cx,bx           {cx:=x+Length}
  add   cx,si
  and   cx,07h          {cx and 07}
  mov   ah,0ffh
  shr   ah,cl           {BitMask}
  cmp   ah,0
  je    @D_End
  not   ah
  mov   al,8            {BitMask Register}
  out   dx,ax           {Write BitMask}
  mov   cl,[es:di]
  mov   al,[Color]
  mov   [es:di],al
  jmp   @D_End
@D_One:
  mov   ah,0ffh
  shr   ah,cl           {Left BitMask}
  add   bx,si
  dec   bx
  and   bx,07h
  mov   cx,7
  sub   cx,bx
  mov   bl,0ffh
  shl   bl,cl          {Right BitMask}
  and   ah,bl          {Full  BitMask}
  mov   al,8           {BitMask Register}
  out   dx,ax          {Write BitMask}
  mov   dl,[es:di]     {Fill Latches}
  mov   al,[Color]
  mov   [es:di],al     {Write Pixel}
@D_End:
 end;

Procedure Rectangle12h(x,y,x1,y1:word;Color:byte);
begin
  HLine(x,y,x1-x,Color);
  VLine(x1-1,y,y1-y,Color);
  HLine(x,y1-1,x1-x,Color);
  VLine(x,y,y1-y,Color);
end;

procedure frame12h(x,y,x1,y1:integer;b,b1,b2,b3:byte);
begin
  HLine(x,y,x1-x,b);
  VLine(x1-1,y,y1-y,b1);
  HLine(x,y1-1,x1-x,b2);
  VLine(x,y,y1-y,b3);
end;

Procedure Bar12h(x,y,Width,Height:word;Color:byte);Assembler;
asm
  mov   ax, [Width]
  sub   ax, [x]
  mov   [Width], ax

  mov   ax, [Height]
  sub   ax, [y]
  mov   [Height], ax

  mov   bx,[x]
  mov   si,[Width]
  or    si,si           {Check if Length=0}
  jz    @D_End           {If So then jump to End}
  mov   ax,SegA000      {Calculate Offset}
  mov   es,ax
  mov   ax,[y]
  mov   di,ax
  shl   di,6            {80*y}
  shl   ax,4
  add   di,ax
  mov   ax,bx
  shr   ax,3            {/8}
  add   di,ax           {80*y+ (x/8)}
  mov   cx,bx           {Get StartBit}
  and   cx,07h
  mov   ax,si
  add   ax,cx
  cmp   ax,8            {Is x+Length<One Byte}
  jb    @D_One
  mov   ah,0ffh         {11111111b}
  shr   ah,cl           {BitMask}
  mov   al,8            {BitMask Register}
  mov   dx,03ceh        {Graphics Controller}
  out   dx,ax           {Write BitMask}
  push  cx
  mov   ah,[Color]
  mov   cx,[Height]
  mov   dx,di
@D_LL:                   {Draw Left of Box}
  mov   al,[es:di]
  mov   [es:di],ah
  add   di,80           {di:=di+80}
  dec   cx
  jnz   @D_LL
  mov   di,dx
  inc   di
  pop   cx
  mov   al,8            {BitMask Register}
  mov   ah,0ffh         {BitMask}
  mov   dx,03ceh        {Graphics Controller}
  out   dx,ax           {Write BitMask}
  mov   ax,si
  mov   ch,8
  sub   ch,cl
  mov   cl,ch
  xor   ch,ch
  sub   ax,cx
  shr   ax,3            {Length div 8}
  push  di
  push  bx
  mov   bx,[Height]
  mov   dx,ax
  mov   al,[Color]
@D_LC:
  mov   cx,dx
  rep   stosb
  add   di,80
  sub   di,dx
  dec   bx
  jnz   @D_LC
  pop   bx
  pop   di
  add   di,dx
  mov   cx,bx           {cx:=x+Length}
  add   cx,si
  and   cx,07h          {cx and 07}
  mov   ah,0ffh
  shr   ah,cl           {BitMask}
  cmp   ah,0
  je    @D_End
  not   ah
  mov   al,8            {BitMask Register}
  mov   dx,03ceh        {Graphics Controller}
  out   dx,ax           {Write BitMask}
  mov   cx,[Height]
  mov   al,[Color]
@D_LR:
  mov   ah,[es:di]
  mov   [es:di],al
  add   di,80
  dec   cx
  jnz   @D_LR
  jmp   @D_End
@D_One:
  mov   ah,0ffh
  shr   ah,cl           {Left BitMask}
  add   bx,si
  dec   bx
  and   bx,07h
  mov   cx,7
  sub   cx,bx
  mov   bl,0ffh
  shl   bl,cl          {Right BitMask}
  and   ah,bl          {Full  BitMask}
  mov   al,8           {BitMask Register}
  mov   dx,03ceh        {Graphics Controller}
  out   dx,ax          {Write BitMask}
  mov   cx,[Height]
  mov   al,[Color]
@D_L:
  mov   dl,[es:di]     {Fill Latches}
  mov   [es:di],al     {Write Pixel}
  add   di,80
  dec   cx
  jnz   @D_L
@D_End:
 end;

function getpixel12h(x, y : WORD) : BYTE; ASSEMBLER;
ASM
  MOV  AX, 80
  MUL  y
  MOV  SI, x
  MOV  CX, SI
  SHR  SI, 3
  ADD  SI, AX
  AND  CL, $07
  XOR  CL, $07
  MOV  CH, 1
  SHL  CH, CL
  {$IFDEF DPMI}
  MOV  ES, SEGA000
  {$ELSE}
  MOV  AX, $A000
  MOV  ES, AX
  {$ENDIF}
  MOV  DX, $03CE
  MOV  AX, 772
  XOR  BL, BL
@gp1:
  OUT  DX, AX
  MOV  BH, ES:[SI]
  AND  BH, CH
  NEG  BH
  ROL  BX, $0001
  DEC  AH
  JGE  @gp1
  MOV  AL, BL
END;

procedure putpicture12h(vx,vy:word;p:pointer);
var i,l,x,y:integer;se:word;off:word;
begin
 se:=seg(p^);off:=ofs(p^);
 x:=memw[se:off];
 y:=memw[se:off+2];
 for l:=0 to y-1 do
 for i:=0 to x-2 do
 begin
  if mem[se:off+4+(l*x)+i]<>ignorecolor then
  putpixel(i+vx,l+vy,mem[se:off+(l*x)+4+i]);
 end;
end;